package forest;

import javax.swing.tree.*;
import java.io.*;
import java.util.logging.Level;
import java.util.logging.Logger;

public class Window extends javax.swing.JFrame {

    public Window() {
        initComponents();
        setup ();
    }
    
    private DefaultTreeModel m;
    
    private void display (DefaultMutableTreeNode branch,
                          File file,
                          int level)
    {
        MyObject myobj = new MyObject ();
        myobj.fileName = file.getAbsolutePath();
        myobj.shortName = file.getName();
        
        DefaultMutableTreeNode node =
           new DefaultMutableTreeNode (myobj);
        branch.add (node);
            
        if (level > 1 && file.isDirectory())
        {
            File [] files = file.listFiles ();
            if (files != null)
               for (File f : files)
                   display (node, f, level-1);
        }
    }
    
    private void setup ()
    {
       File dir = new File ("c:\\temp");
       try 
       {
         dir = new File (dir.getCanonicalPath());
         

         DefaultMutableTreeNode root = 
             new DefaultMutableTreeNode 
                  (dir.getParent());
       
         display (root, dir, 3);

         m = new DefaultTreeModel (root);
         jTree1.setModel (m);
       } 
       catch (IOException ex) 
       { 
       }
       
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jSplitPane1 = new javax.swing.JSplitPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTree1 = new javax.swing.JTree();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jSplitPane1.setDividerLocation(200);

        jTree1.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
            public void valueChanged(javax.swing.event.TreeSelectionEvent evt) {
                jTree1ValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(jTree1);

        jSplitPane1.setLeftComponent(jScrollPane1);

        jTextArea1.setColumns(20);
        jTextArea1.setRows(5);
        jScrollPane2.setViewportView(jTextArea1);

        jSplitPane1.setRightComponent(jScrollPane2);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(19, 19, 19)
                .addComponent(jSplitPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 371, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(28, 28, 28)
                .addComponent(jSplitPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 261, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jTree1ValueChanged(javax.swing.event.TreeSelectionEvent evt) {//GEN-FIRST:event_jTree1ValueChanged
        TreePath [] p = evt.getPaths();
        for (TreePath t : p)
            if (evt.isAddedPath(t))
            {
                DefaultMutableTreeNode obj = 
                   (DefaultMutableTreeNode) 
                        t.getLastPathComponent();
                
                MyObject myobj = 
                        (MyObject) obj.getUserObject();
                
                setTitle(""+myobj.fileName);
                click (myobj.fileName);
            }
    }//GEN-LAST:event_jTree1ValueChanged

    
    private void click (String fileName)
    {
        try {
            // InputStreamReader reader = 
            //       new FileReader (fileName);
            BufferedInputStream reader = 
                new BufferedInputStream 
                    (new FileInputStream (fileName));
           
            StringBuilder b = new StringBuilder ();
            int n = reader.read();
            while (n != -1)
            {
                b.append ((char) n);
                n = reader.read();
            }
            jTextArea1.setText (b.toString());
        }
        catch (IOException ex) {
        }
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Window.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Window.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Window.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Window.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Window().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTree jTree1;
    // End of variables declaration//GEN-END:variables
}
